//
//	-> http://earthlingsoft.net/hacks/
//
//  esScribbleView.h
//  Scribbler
//
//  Created by Sven-S. Porst on Sat Aug 02 2003.
//  Copyright (c) 2003 earthlingsoft. All rights reserved.
//

#import "esScribbleView.h"

@implementation esScribbleView

- (id)initWithFrame:(NSRect)frameRect
{
	self = [super initWithFrame:frameRect];
	scribblePaths = [[NSMutableArray alloc] init];
	return self;
}

- (void)drawRect:(NSRect)rect
{
	NSEnumerator * myEnum = [scribblePaths objectEnumerator];
	esScribblePath * scribble;
	NSBezierPath * path;
	
	[[NSColor whiteColor] set];
	NSRectFill(rect);

	while (scribble = [myEnum nextObject]) {
		path = [scribble path];
		if (NSIntersectsRect(rect,[path bounds])) {
			[scribble draw];
		}
	}
}

- (void)mouseDown:(NSEvent *)theEvent
{
	NSPoint mouseLoc = [self convertPoint:[theEvent locationInWindow] fromView:[[self window] contentView]];
	esScribblePath * scribble = [esScribblePath scribblePathWithColor:[self currentColor]];
	[scribblePaths addObject:scribble];
	NSBezierPath * path = [scribble path];
	[path setLineWidth:[self currentLineWidth]];
	[path moveToPoint:mouseLoc];
}

- (void)mouseDragged:(NSEvent *)theEvent
{
	NSPoint mouseLoc = [self convertPoint:[theEvent locationInWindow]  fromView:[[self window] contentView]];
	esScribblePath * scribble = [scribblePaths lastObject];
	NSBezierPath * path = [scribble path];
	[path lineToPoint:mouseLoc];
	[self setNeedsDisplayInRect:NSInsetRect([path bounds],-1.0,-1.0)];
//	NSLog(@"point %i", [path elementCount]);
}



- (float) currentLineWidth
{
	switch ([[PenThicknessMatrix selectedCell] tag]) {
		case 0:
			return 1.0;
		case 1:
			return 2.0;
		case 2:
			return 3.0;
		default:
			NSBeep();
	}
	return 1.0;
}


- (NSColor*) currentColor {
	switch ([[PenColorMatrix selectedCell] tag]) {
		case 0:
			return [NSColor blackColor];
		case 1:
			return [NSColor redColor];
		case 2:
			return [NSColor blueColor];
		default:
			NSBeep();
	}
	return [NSColor blackColor];
}
	

- (IBAction)penColorChanged:(id)sender
{
}

- (IBAction)penModeChanged:(id)sender
{
}

- (IBAction)penThicknessChanged:(id)sender
{
}

- (void) dealloc
{
	[scribblePaths release];
	[super dealloc];
}

@end
